using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;
// <auto-generated />
namespace NorthwindAccess{
    /// <summary>
    /// Strongly-typed collection for the TenMostExpensiveProduct class.
    /// </summary>
    [Serializable]
    public partial class TenMostExpensiveProductCollection : ReadOnlyList<TenMostExpensiveProduct, TenMostExpensiveProductCollection>
    {        
        public TenMostExpensiveProductCollection() {}
    }
    /// <summary>
    /// This is  Read-only wrapper class for the Ten Most Expensive Products view.
    /// </summary>
    [Serializable]
    public partial class TenMostExpensiveProduct : ReadOnlyRecord<TenMostExpensiveProduct>, IReadOnlyRecord
    {
    
	    #region Default Settings
	    protected static void SetSQLProps() 
	    {
		    GetTableSchema();
	    }
	    #endregion
        #region Schema Accessor
	    public static TableSchema.Table Schema
        {
            get
            {
                if (BaseSchema == null)
                {
                    SetSQLProps();
                }
                return BaseSchema;
            }
        }
    	
        private static void GetTableSchema() 
        {
            if(!IsSchemaInitialized)
            {
                //Schema declaration
                TableSchema.Table schema = new TableSchema.Table("Ten Most Expensive Products", TableType.View, DataService.GetInstance("NorthwindAccess"));
                schema.Columns = new TableSchema.TableColumnCollection();
                schema.SchemaName = @"";
                //columns
                
                TableSchema.TableColumn colvarTenMostExpensiveProducts = new TableSchema.TableColumn(schema);
                colvarTenMostExpensiveProducts.ColumnName = "TenMostExpensiveProducts";
                colvarTenMostExpensiveProducts.DataType = DbType.String;
                colvarTenMostExpensiveProducts.MaxLength = 40;
                colvarTenMostExpensiveProducts.AutoIncrement = false;
                colvarTenMostExpensiveProducts.IsNullable = true;
                colvarTenMostExpensiveProducts.IsPrimaryKey = false;
                colvarTenMostExpensiveProducts.IsForeignKey = false;
                colvarTenMostExpensiveProducts.IsReadOnly = false;
                
                schema.Columns.Add(colvarTenMostExpensiveProducts);
                
                TableSchema.TableColumn colvarUnitPrice = new TableSchema.TableColumn(schema);
                colvarUnitPrice.ColumnName = "UnitPrice";
                colvarUnitPrice.DataType = DbType.Currency;
                colvarUnitPrice.MaxLength = 0;
                colvarUnitPrice.AutoIncrement = false;
                colvarUnitPrice.IsNullable = true;
                colvarUnitPrice.IsPrimaryKey = false;
                colvarUnitPrice.IsForeignKey = false;
                colvarUnitPrice.IsReadOnly = false;
                
                schema.Columns.Add(colvarUnitPrice);
                
                
                BaseSchema = schema;
                //add this schema to the provider
                //so we can query it later
                DataService.Providers["NorthwindAccess"].AddSchema("Ten Most Expensive Products",schema);
            }
        }
        #endregion
        
        #region Query Accessor
	    public static Query CreateQuery()
	    {
		    return new Query(Schema);
	    }
	    #endregion
	    
	    #region .ctors
	    public TenMostExpensiveProduct()
	    {
            SetSQLProps();
            SetDefaults();
            MarkNew();
        }
        public TenMostExpensiveProduct(bool useDatabaseDefaults)
	    {
		    SetSQLProps();
		    if(useDatabaseDefaults)
		    {
				ForceDefaults();
			}
			MarkNew();
	    }
	    
	    public TenMostExpensiveProduct(object keyID)
	    {
		    SetSQLProps();
		    LoadByKey(keyID);
	    }
    	 
	    public TenMostExpensiveProduct(string columnName, object columnValue)
        {
            SetSQLProps();
            LoadByParam(columnName,columnValue);
        }
        
	    #endregion
	    
	    #region Props
	    
          
        [XmlAttribute("TenMostExpensiveProducts")]
        [Bindable(true)]
        public string TenMostExpensiveProducts 
	    {
		    get
		    {
			    return GetColumnValue<string>("TenMostExpensiveProducts");
		    }
            set 
		    {
			    SetColumnValue("TenMostExpensiveProducts", value);
            }
        }
	      
        [XmlAttribute("UnitPrice")]
        [Bindable(true)]
        public decimal? UnitPrice 
	    {
		    get
		    {
			    return GetColumnValue<decimal?>("UnitPrice");
		    }
            set 
		    {
			    SetColumnValue("UnitPrice", value);
            }
        }
	    
	    #endregion
    
	    #region Columns Struct
	    public struct Columns
	    {
		    
		    
            public static string TenMostExpensiveProducts = @"TenMostExpensiveProducts";
            
            public static string UnitPrice = @"UnitPrice";
            
	    }
	    #endregion
	    
	    
	    #region IAbstractRecord Members
        public new CT GetColumnValue<CT>(string columnName) {
            return base.GetColumnValue<CT>(columnName);
        }
        public object GetColumnValue(string columnName) {
            return base.GetColumnValue<object>(columnName);
        }
        #endregion
	    
    }
}
