using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;
// <auto-generated />
namespace SouthwindRepository
{
	/// <summary>
	/// Strongly-typed collection for the Customerdemographic class.
	/// </summary>
    [Serializable]
	public partial class CustomerdemographicCollection : RepositoryList<Customerdemographic, CustomerdemographicCollection>
	{	   
		public CustomerdemographicCollection() {}
        
        /// <summary>
		/// Filters an existing collection based on the set criteria. This is an in-memory filter
		/// Thanks to developingchris for this!
        /// </summary>
        /// <returns>CustomerdemographicCollection</returns>
		public CustomerdemographicCollection Filter()
        {
            for (int i = this.Count - 1; i > -1; i--)
            {
                Customerdemographic o = this[i];
                foreach (SubSonic.Where w in this.wheres)
                {
                    bool remove = false;
                    System.Reflection.PropertyInfo pi = o.GetType().GetProperty(w.ColumnName);
                    if (pi.CanRead)
                    {
                        object val = pi.GetValue(o, null);
                        switch (w.Comparison)
                        {
                            case SubSonic.Comparison.Equals:
                                if (!val.Equals(w.ParameterValue))
                                {
                                    remove = true;
                                }
                                break;
                        }
                    }
                    if (remove)
                    {
                        this.Remove(o);
                        break;
                    }
                }
            }
            return this;
        }
		
		
	}
	/// <summary>
	/// This is an ActiveRecord class which wraps the customerdemographics table.
	/// </summary>
	[Serializable]
	public partial class Customerdemographic : RepositoryRecord<Customerdemographic>, IRecordBase
	{
		#region .ctors and Default Settings
		
		public Customerdemographic()
		{
		  SetSQLProps();
		  InitSetDefaults();
		  MarkNew();
		}
		
		private void InitSetDefaults() { SetDefaults(); }
		
		public Customerdemographic(bool useDatabaseDefaults)
		{
			SetSQLProps();
			if(useDatabaseDefaults)
				ForceDefaults();
			MarkNew();
		}
        
		protected static void SetSQLProps() { GetTableSchema(); }
		
		#endregion
		
		#region Schema and Query Accessor	
		public static Query CreateQuery() { return new Query(Schema); }
		public static TableSchema.Table Schema
		{
			get
			{
				if (BaseSchema == null)
					SetSQLProps();
				return BaseSchema;
			}
		}
		
		private static void GetTableSchema() 
		{
			if(!IsSchemaInitialized)
			{
				//Schema declaration
				TableSchema.Table schema = new TableSchema.Table("customerdemographics", TableType.Table, DataService.GetInstance("SouthwindRepository"));
				schema.Columns = new TableSchema.TableColumnCollection();
				schema.SchemaName = @"";
				//columns
				
				TableSchema.TableColumn colvarCustomerTypeID = new TableSchema.TableColumn(schema);
				colvarCustomerTypeID.ColumnName = "CustomerTypeID";
				colvarCustomerTypeID.DataType = DbType.AnsiStringFixedLength;
				colvarCustomerTypeID.MaxLength = 10;
				colvarCustomerTypeID.AutoIncrement = false;
				colvarCustomerTypeID.IsNullable = false;
				colvarCustomerTypeID.IsPrimaryKey = true;
				colvarCustomerTypeID.IsForeignKey = false;
				colvarCustomerTypeID.IsReadOnly = false;
				colvarCustomerTypeID.DefaultSetting = @"";
				colvarCustomerTypeID.ForeignKeyTableName = "";
				schema.Columns.Add(colvarCustomerTypeID);
				
				TableSchema.TableColumn colvarCustomerDesc = new TableSchema.TableColumn(schema);
				colvarCustomerDesc.ColumnName = "CustomerDesc";
				colvarCustomerDesc.DataType = DbType.String;
				colvarCustomerDesc.MaxLength = 0;
				colvarCustomerDesc.AutoIncrement = false;
				colvarCustomerDesc.IsNullable = true;
				colvarCustomerDesc.IsPrimaryKey = false;
				colvarCustomerDesc.IsForeignKey = false;
				colvarCustomerDesc.IsReadOnly = false;
				colvarCustomerDesc.DefaultSetting = @"";
				colvarCustomerDesc.ForeignKeyTableName = "";
				schema.Columns.Add(colvarCustomerDesc);
				
				BaseSchema = schema;
				//add this schema to the provider
				//so we can query it later
				DataService.Providers["SouthwindRepository"].AddSchema("customerdemographics",schema);
			}
		}
		#endregion
		
		#region Props
		  
		[XmlAttribute("CustomerTypeID")]
		[Bindable(true)]
		public string CustomerTypeID 
		{
			get { return GetColumnValue<string>(Columns.CustomerTypeID); }
			set { SetColumnValue(Columns.CustomerTypeID, value); }
		}
		  
		[XmlAttribute("CustomerDesc")]
		[Bindable(true)]
		public string CustomerDesc 
		{
			get { return GetColumnValue<string>(Columns.CustomerDesc); }
			set { SetColumnValue(Columns.CustomerDesc, value); }
		}
		
		#endregion
		
		
			
		
		//no foreign key tables defined (0)
		
		
		
		//no ManyToMany tables defined (0)
		
        
        
        
        
        #region Typed Columns
        
        
        public static TableSchema.TableColumn CustomerTypeIDColumn
        {
            get { return Schema.Columns[0]; }
        }
        
        
        
        public static TableSchema.TableColumn CustomerDescColumn
        {
            get { return Schema.Columns[1]; }
        }
        
        
        
        #endregion
		#region Columns Struct
		public struct Columns
		{
			 public static string CustomerTypeID = @"CustomerTypeID";
			 public static string CustomerDesc = @"CustomerDesc";
						
		}
		#endregion
		
		#region Update PK Collections
		
        #endregion
    
        #region Deep Save
		
        #endregion
	}
}
